//
//  iPrivateAES.h
//  iPrivateAES
//
//  Created by Marcello Quaglia on 21/09/15.
//  Copyright © 2015 centrosicurezza. All rights reserved.
//
//~shortname:iPrivateAES
//~event:AES_Set_TCP_Key(bytes() as byte)
//~event:AES_Set_GPRS_Key(bytes() as byte)
//~event:AES_Encrypt_TCP(buffer() as byte, BufferSize as int, ConnectionMode as byte)
//~event:AES_Decrypt_TCP(buffer() as byte, BufferSize as int, ConnectionMode as byte)
//~version:1.00


#import <Foundation/Foundation.h>

@interface iPrivateAES : NSObject

#define LAN_MODE 1
#define GPRS_MODE 2

extern unsigned char AES128KeyTcpIp[16];
extern unsigned char AES128KeyGprs[16];


-(void) AES_init_tcp_key;
-(void) AES_init_gprs_key;
-(void) AES_set_tcp_key :(unsigned char*) prandom;
-(void) AES_set_gprs_key :(unsigned char*) prandom;
-(void) AES_encrypt_tcp :(unsigned char*) pplainbuffer :(unsigned long)plainbuffersize :(unsigned char)mode;
-(void) AES_decrypt_tcp :(unsigned char*) pencryptedbuffer :(unsigned long)encryptedbuffersize :(unsigned char)mode;
-(void) aes_enc_dec :(unsigned char *)state :(unsigned char *)key :(unsigned char)dir;
-(unsigned char) galois_mul2: (unsigned char) value;


@end
